//
//	$Date: 2001/07/26 14:47:11 $
//	$Revision: 1.3 $
//
#if SDK_VERSION >= 35
#include <PalmOS.h>
#else
#include <Pilot.h>
#include "NewTypes.h"
#endif

//#include <SonyCLIE.h>
#include "SonyChars.h"
#include "palmwiki.h"
#include "pwprefs.h"
#include "linkaction.h"

static Boolean JumpApp(LinkActionType);

typedef Boolean SysHandleEventTrapFunc(EventType* event);

// This function must put at the top of this file.
Boolean SysHandleEventHack(EventType *event)
{
	SysHandleEventTrapFunc *trapfunc;

	// Get the original trap address of EvtGetEvent and call it.
	FtrGet(PWCREATOR,1001,(UInt32*)(&trapfunc));

	if(event->eType == keyDownEvent){
		switch(event->data.keyDown.chr){
		case vchrJogBack:
		case prevFieldChr:
			if(JumpApp(LINKBACKWARD)){
				event->eType = nilEvent;
				return true;
			}
			break;
		case vchrJogRelease:
		case nextFieldChr:
			if(JumpApp(LINKFORWARD)){
				event->eType = nilEvent;
				return true;
			}
			break;
		default:
			break;
		}
	}

	return (*trapfunc)(event);
}

#ifdef USEGETEVENT
typedef void EvtGetEventTrapFunc(EventType*, Int32);

// This function must put at the top of this file.
void EvtGetEventHack(EventType *event, Int32 timeout)
{
	EvtGetEventTrapFunc *trapfunc;

	// Get the original trap address of EvtGetEvent and call it.
	FtrGet(PWCREATOR,1001,(UInt32*)(&trapfunc));

	(*trapfunc)(event,timeout);

	if(event->eType == keyDownEvent &&
	   event->data.keyDown.chr == vchrJogBack){
		if(JumpApp(JUMPBACK)) event->eType = nilEvent;
	}
}
#endif

Boolean JumpApp(LinkActionType action)
{
	GoToParamsType *cmdPBP;
	WikiPref pref;
	Link *link;

	DmOpenRef db;
	LocalID id;
	UInt16 cardno;
	UInt32 type,creator;
	Boolean jumpenable = false;

	// Go back to prev app when memo DB is currently open or
	// PalmWiki-related apps are running

	// Check all the open database and see if memo is currently open
	db = DmNextOpenDatabase(NULL);
	while(db){
		DmOpenDatabaseInfo(db,&id,
			NULL,NULL,&cardno,NULL);
		DmDatabaseInfo(cardno,id,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			NULL,NULL,NULL,
			&type,&creator);
		if(type == 'DATA' && creator == 'memo'){
			jumpenable = true;
			break;
		}
		if(type == 'appl' && (
			creator == 'memo' || // standard memo app
			creator == 'date' || // standard schedule app
			creator == 'SNMM' || // Snap!Memo
			creator == 'QPKT'    // Q-Pocket
			)){
			jumpenable = true;
			break;
		}
		db = DmNextOpenDatabase(db);
	}
	if(! jumpenable) return false;

	if(!LinkAction(action)) return false;

	GetWikiPreferences(&pref,false);

	link = &(pref.linkstack[pref.linkstackindex]);
	if(link->recordno == 0xffff){
		// If no record was found, just jump back to the previous application.
		SysUIAppSwitch(link->appcardno,link->appid,sysAppLaunchCmdNormalLaunch,NULL);
	}
	else {
		// Jump to a specific record.
		cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
		cmdPBP->searchStrLen = 0;
		cmdPBP->dbCardNo = link->datacardno;
		cmdPBP->dbID = link->dataid;
		cmdPBP->recordNum = link->recordno;
		cmdPBP->matchPos = 0;
		cmdPBP->matchFieldNum = 0; 
		cmdPBP->matchCustom = 0;
		MemPtrSetOwner((MemPtr)cmdPBP,0);
		SysUIAppSwitch(link->appcardno,link->appid,sysAppLaunchCmdGoTo,(MemPtr)cmdPBP);
	}
	return true;
}





